      subroutine ebirxn5(ny,nr,yh,H2O,M,O2,CH4,H2,rk,r)
      implicit none
c
c----CAMx v5.20.1 1007014
c
c     EBIRXN5 computes reaction rates for the EBI solver
c
c     Copyright 1996 - 2010
c     ENVIRON International Corporation
c     Created by the CMC version 5.2
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        ny  - dimension of y
c        nr  - dimension of r and rk
c        yh  - current y (ppm)
c        H2O - water vapor Concentration (ppm)
c        M   - total gas Concentration (ppm)
c        O2  - oxygen Concentration (ppm)
c        CH4 - methane Concentration (ppm)
c        H2  - hydrogen Concentration (ppm)
c        rk  - rate constants (units ppm hr)
c        r   - reaction rates (hr-1)
c
c --- Includes:
      include "camx.prm"
      include "chmdat.com"
      include "ddmchm.com"
c
c --- Arguments:
      integer ny, nr
      real    yh(ny+1)
      real    r(nr), rk(nr)
      real    H2O,M,O2,CH4,H2
c
c --- Local variables:
      real    N2
c
c --- Entry point
c
      N2  = M - O2
c
c --- Calculate reaction rates
c
      r(  1) = rk(  1)*yh(lNO2)
      r(  2) = rk(  2)*yh(lO)*O2*M
      r(  3) = rk(  3)*yh(lO)*yh(lO3)
      r(  4) = rk(  4)*yh(lO)*yh(lNO)*M
      r(  5) = rk(  5)*yh(lO)*yh(lNO2)
      r(  6) = rk(  6)*yh(lO)*yh(lNO2)
      r(  7) = rk(  7)*yh(lO3)*yh(lNO)
      r(  8) = rk(  8)*yh(lO3)*yh(lNO2)
      r(  9) = rk(  9)*yh(lNO)*yh(lNO3)
      r( 10) = rk( 10)*yh(lNO)*yh(lNO)*O2
      r( 11) = rk( 11)*yh(lNO2)*yh(lNO3)
      r( 12) = rk( 12)*yh(lN2O5)
      r( 13) = rk( 13)*yh(lN2O5)*H2O
      r( 14) = rk( 14)*yh(lNO2)*yh(lNO3)
      r( 15) = rk( 15)*yh(lNO3)
      r( 16) = rk( 16)*yh(lNO3)
      r( 17) = rk( 17)*yh(lO3)
      r( 18) = rk( 18)*yh(lO3)
      r( 19) = rk( 19)*yh(lO1D)*H2O
      r( 20) = rk( 20)*yh(lO1D)*M
      r( 21) = rk( 21)*yh(lOH)*yh(lNO)
      r( 22) = rk( 22)*yh(lHONO)
      r( 23) = rk( 23)*yh(lHONO)
      r( 24) = rk( 24)*yh(lOH)*yh(lHONO)
      r( 25) = rk( 25)*yh(lOH)*yh(lNO2)
      r( 26) = rk( 26)*yh(lOH)*yh(lNO3)
      r( 27) = rk( 27)*yh(lOH)*yh(lHNO3)
      r( 28) = rk( 28)*yh(lHNO3)
      r( 29) = rk( 29)*yh(lOH)*yh(lCO)
      r( 30) = rk( 30)*yh(lOH)*yh(lO3)
      r( 31) = rk( 31)*yh(lHO2)*yh(lNO)
      r( 32) = rk( 32)*yh(lHO2)*yh(lNO2)
      r( 33) = rk( 33)*yh(lHNO4)
      r( 34) = rk( 34)*yh(lHNO4)
      r( 35) = rk( 35)*yh(lHNO4)*yh(lOH)
      r( 36) = rk( 36)*yh(lHO2)*yh(lO3)
      r( 37) = rk( 37)*yh(lHO2)*yh(lHO2)
      r( 38) = rk( 38)*yh(lHO2)*yh(lHO2)*H2O
      r( 39) = rk( 39)*yh(lNO3)*yh(lHO2)
      r( 40) = rk( 40)*yh(lNO3)*yh(lNO3)
      r( 41) = rk( 41)*yh(lHO2H)
      r( 42) = rk( 42)*yh(lHO2H)*yh(lOH)
      r( 43) = rk( 43)*yh(lOH)*yh(lHO2)
      r( 44) = rk( 44)*yh(lOH)*yh(lSO2)
      r( 45) = rk( 45)*yh(lOH)*H2
      r( 46) = rk( 46)*yh(lCXO2)*yh(lNO)
      r( 47) = rk( 47)*yh(lCXO2)*yh(lHO2)
      r( 48) = rk( 48)*yh(lCXO2)*yh(lNO3)
      r( 49) = rk( 49)*yh(lCXO2)*yh(lCXO2)
      r( 50) = rk( 50)*yh(lCXO2)*yh(lCXO2)
      r( 51) = rk( 51)*yh(lRO2R)*yh(lNO)
      r( 52) = rk( 52)*yh(lRO2R)*yh(lHO2)
      r( 53) = rk( 53)*yh(lRO2R)*yh(lNO3)
      r( 54) = rk( 54)*yh(lRO2R)*yh(lCXO2)
      r( 55) = rk( 55)*yh(lRO2R)*yh(lRO2R)
      r( 56) = rk( 56)*yh(lR2O2)*yh(lNO)
      r( 57) = rk( 57)*yh(lR2O2)*yh(lHO2)
      r( 58) = rk( 58)*yh(lR2O2)*yh(lNO3)
      r( 59) = rk( 59)*yh(lR2O2)*yh(lCXO2)
      r( 60) = rk( 60)*yh(lR2O2)*yh(lRO2R)
      r( 61) = rk( 61)*yh(lR2O2)*yh(lR2O2)
      r( 62) = rk( 62)*yh(lRO2N)*yh(lNO)
      r( 63) = rk( 63)*yh(lRO2N)*yh(lHO2)
      r( 64) = rk( 64)*yh(lRO2N)*yh(lCXO2)
      r( 65) = rk( 65)*yh(lRO2N)*yh(lNO3)
      r( 66) = rk( 66)*yh(lRO2N)*yh(lRO2R)
      r( 67) = rk( 67)*yh(lRO2N)*yh(lR2O2)
      r( 68) = rk( 68)*yh(lRO2N)*yh(lRO2N)
      r( 69) = rk( 69)*yh(lCCO3)*yh(lNO2)
      r( 70) = rk( 70)*yh(lPAN)
      r( 71) = rk( 71)*yh(lCCO3)*yh(lNO)
      r( 72) = rk( 72)*yh(lCCO3)*yh(lHO2)
      r( 73) = rk( 73)*yh(lCCO3)*yh(lNO3)
      r( 74) = rk( 74)*yh(lCCO3)*yh(lCXO2)
      r( 75) = rk( 75)*yh(lCCO3)*yh(lRO2R)
      r( 76) = rk( 76)*yh(lCCO3)*yh(lR2O2)
      r( 77) = rk( 77)*yh(lCCO3)*yh(lRO2N)
      r( 78) = rk( 78)*yh(lCCO3)*yh(lCCO3)
      r( 79) = rk( 79)*yh(lRCO3)*yh(lNO2)
      r( 80) = rk( 80)*yh(lPAN2)
      r( 81) = rk( 81)*yh(lRCO3)*yh(lNO)
      r( 82) = rk( 82)*yh(lRCO3)*yh(lHO2)
      r( 83) = rk( 83)*yh(lRCO3)*yh(lNO3)
      r( 84) = rk( 84)*yh(lRCO3)*yh(lCXO2)
      r( 85) = rk( 85)*yh(lRCO3)*yh(lRO2R)
      r( 86) = rk( 86)*yh(lRCO3)*yh(lR2O2)
      r( 87) = rk( 87)*yh(lRCO3)*yh(lRO2N)
      r( 88) = rk( 88)*yh(lRCO3)*yh(lCCO3)
      r( 89) = rk( 89)*yh(lRCO3)*yh(lRCO3)
      r( 90) = rk( 90)*yh(lBZCO)*yh(lNO2)
      r( 91) = rk( 91)*yh(lPBZN)
      r( 92) = rk( 92)*yh(lBZCO)*yh(lNO)
      r( 93) = rk( 93)*yh(lBZCO)*yh(lHO2)
      r( 94) = rk( 94)*yh(lBZCO)*yh(lNO3)
      r( 95) = rk( 95)*yh(lBZCO)*yh(lCXO2)
      r( 96) = rk( 96)*yh(lBZCO)*yh(lRO2R)
      r( 97) = rk( 97)*yh(lBZCO)*yh(lR2O2)
      r( 98) = rk( 98)*yh(lBZCO)*yh(lRO2N)
      r( 99) = rk( 99)*yh(lBZCO)*yh(lCCO3)
      r(100) = rk(100)*yh(lBZCO)*yh(lRCO3)
      r(101) = rk(101)*yh(lBZCO)*yh(lBZCO)
      r(102) = rk(102)*yh(lMCO3)*yh(lNO2)
      r(103) = rk(103)*yh(lMPAN)
      r(104) = rk(104)*yh(lMCO3)*yh(lNO)
      r(105) = rk(105)*yh(lMCO3)*yh(lHO2)
      r(106) = rk(106)*yh(lMCO3)*yh(lNO3)
      r(107) = rk(107)*yh(lMCO3)*yh(lCXO2)
      r(108) = rk(108)*yh(lMCO3)*yh(lRO2R)
      r(109) = rk(109)*yh(lMCO3)*yh(lR2O2)
      r(110) = rk(110)*yh(lMCO3)*yh(lRO2N)
      r(111) = rk(111)*yh(lMCO3)*yh(lCCO3)
      r(112) = rk(112)*yh(lMCO3)*yh(lRCO3)
      r(113) = rk(113)*yh(lMCO3)*yh(lBZCO)
      r(114) = rk(114)*yh(lMCO3)*yh(lMCO3)
      r(115) = rk(115)*yh(lTBUO)*yh(lNO2)
      r(116) = rk(116)*yh(lTBUO)
      r(117) = rk(117)*yh(lBZO)*yh(lNO2)
      r(118) = rk(118)*yh(lBZO)*yh(lHO2)
      r(119) = rk(119)*yh(lBZO)
      r(120) = rk(120)*yh(lBZNO)*yh(lNO2)
      r(121) = rk(121)*yh(lBZNO)*yh(lHO2)
      r(122) = rk(122)*yh(lBZNO)
      r(123) = rk(123)*yh(lHCHO)
      r(124) = rk(124)*yh(lHCHO)
      r(125) = rk(125)*yh(lHCHO)*yh(lOH)
      r(126) = rk(126)*yh(lHCHO)*yh(lHO2)
      r(127) = rk(127)*yh(lHCO3)
      r(128) = rk(128)*yh(lHCO3)*yh(lNO)
      r(129) = rk(129)*yh(lHCHO)*yh(lNO3)
      r(130) = rk(130)*yh(lCCHO)*yh(lOH)
      r(131) = rk(131)*yh(lCCHO)
      r(132) = rk(132)*yh(lCCHO)*yh(lNO3)
      r(133) = rk(133)*yh(lRCHO)*yh(lOH)
      r(134) = rk(134)*yh(lRCHO)
      r(135) = rk(135)*yh(lRCHO)*yh(lNO3)
      r(136) = rk(136)*yh(lACET)*yh(lOH)
      r(137) = rk(137)*yh(lACET)
      r(138) = rk(138)*yh(lMEK)*yh(lOH)
      r(139) = rk(139)*yh(lMEK)
      r(140) = rk(140)*yh(lMEOH)*yh(lOH)
      r(141) = rk(141)*yh(lCOOH)*yh(lOH)
      r(142) = rk(142)*yh(lCOOH)
      r(143) = rk(143)*yh(lROOH)*yh(lOH)
      r(144) = rk(144)*yh(lROOH)
      r(145) = rk(145)*yh(lGLY)
      r(146) = rk(146)*yh(lGLY)
      r(147) = rk(147)*yh(lGLY)*yh(lOH)
      r(148) = rk(148)*yh(lGLY)*yh(lNO3)
      r(149) = rk(149)*yh(lMGLY)
      r(150) = rk(150)*yh(lMGLY)*yh(lOH)
      r(151) = rk(151)*yh(lMGLY)*yh(lNO3)
      r(152) = rk(152)*yh(lBACL)
      r(153) = rk(153)*yh(lPHEN)*yh(lOH)
      r(154) = rk(154)*yh(lPHEN)*yh(lNO3)
      r(155) = rk(155)*yh(lCRES)*yh(lOH)
      r(156) = rk(156)*yh(lCRES)*yh(lNO3)
      r(157) = rk(157)*yh(lNPHE)*yh(lNO3)
      r(158) = rk(158)*yh(lBALD)*yh(lOH)
      r(159) = rk(159)*yh(lBALD)
      r(160) = rk(160)*yh(lBALD)*yh(lNO3)
      r(161) = rk(161)*yh(lMETH)*yh(lOH)
      r(162) = rk(162)*yh(lMETH)*yh(lO3)
      r(163) = rk(163)*yh(lMETH)*yh(lNO3)
      r(164) = rk(164)*yh(lMETH)*yh(lO)
      r(165) = rk(165)*yh(lMETH)
      r(166) = rk(166)*yh(lMVK)*yh(lOH)
      r(167) = rk(167)*yh(lMVK)*yh(lO3)
      r(168) = rk(168)*yh(lMVK)*yh(lO)
      r(169) = rk(169)*yh(lMVK)
      r(170) = rk(170)*yh(lISPD)*yh(lOH)
      r(171) = rk(171)*yh(lISPD)*yh(lO3)
      r(172) = rk(172)*yh(lISPD)*yh(lNO3)
      r(173) = rk(173)*yh(lISPD)
      r(174) = rk(174)*yh(lPROD)*yh(lOH)
      r(175) = rk(175)*yh(lPROD)
      r(176) = rk(176)*yh(lRNO3)*yh(lOH)
      r(177) = rk(177)*yh(lRNO3)
      r(178) = rk(178)*yh(lDCB1)*yh(lOH)
      r(179) = rk(179)*yh(lDCB1)*yh(lO3)
      r(180) = rk(180)*yh(lDCB2)*yh(lOH)
      r(181) = rk(181)*yh(lDCB2)
      r(182) = rk(182)*yh(lDCB3)*yh(lOH)
      r(183) = rk(183)*yh(lDCB3)
      r(184) = rk(184)*CH4*yh(lOH)
      r(185) = rk(185)*yh(lETHE)*yh(lOH)
      r(186) = rk(186)*yh(lETHE)*yh(lO3)
      r(187) = rk(187)*yh(lETHE)*yh(lNO3)
      r(188) = rk(188)*yh(lETHE)*yh(lO)
      r(189) = rk(189)*yh(lISOP)*yh(lOH)
      r(190) = rk(190)*yh(lISOP)*yh(lO3)
      r(191) = rk(191)*yh(lISOP)*yh(lNO3)
      r(192) = rk(192)*yh(lISOP)*yh(lO)
      r(193) = rk(193)*yh(lTERP)*yh(lOH)
      r(194) = rk(194)*yh(lTERP)*yh(lO3)
      r(195) = rk(195)*yh(lTERP)*yh(lNO3)
      r(196) = rk(196)*yh(lTERP)*yh(lO)
      r(197) = rk(197)*yh(lALK1)*yh(lOH)
      r(198) = rk(198)*yh(lALK2)*yh(lOH)
      r(199) = rk(199)*yh(lALK3)*yh(lOH)
      r(200) = rk(200)*yh(lALK4)*yh(lOH)
      r(201) = rk(201)*yh(lALK5)*yh(lOH)
      r(202) = rk(202)*yh(lARO1)*yh(lOH)
      r(203) = rk(203)*yh(lARO2)*yh(lOH)
      r(204) = rk(204)*yh(lOLE1)*yh(lOH)
      r(205) = rk(205)*yh(lOLE1)*yh(lO3)
      r(206) = rk(206)*yh(lOLE1)*yh(lNO3)
      r(207) = rk(207)*yh(lOLE1)*yh(lO)
      r(208) = rk(208)*yh(lOLE2)*yh(lOH)
      r(209) = rk(209)*yh(lOLE2)*yh(lO3)
      r(210) = rk(210)*yh(lOLE2)*yh(lNO3)
      r(211) = rk(211)*yh(lOLE2)*yh(lO)
      r(212) = rk(212)*yh(lETOH)*yh(lOH)
      r(213) = rk(213)*yh(lMTBE)*yh(lOH)
      r(214) = rk(214)*yh(lMBUT)*yh(lOH)
      r(215) = rk(215)*yh(lMBUT)*yh(lO3)
      r(216) = rk(216)*yh(lMBUT)*yh(lNO3)
      r(217) = rk(217)*yh(lMBUT)*yh(lO)
c
      return
      end

