      subroutine iejac6(neq,t,y,ml,mu,jac,njac)
      implicit none
c
c----CAMx v5.20.1 1007014
c
c     IEJAC6 computes a Jacobian for the IEH solver
c
c     Copyright 1996 - 2010
c     ENVIRON International Corporation
c     Created by the CMC version 5.2
c
c     Routines Called:
c        IERXN6
c
c     Called by:
c        LSODE
c
      include "camx.prm"
      include "chmdat.com"
      include "iehchem.com"
      include "lsbox.com"
c
      integer ml, mu, njac, neq(3), ny, nk, i, j, l
      real t, tmp, H2O, M, O2, CH4, H2, N2
      real y(neq(2)+6)
      real jac(neq(1),neq(1))
      real r(neq(3))
      real loss(MXSPEC+MXRADCL+1)
      real gain(MXSPEC+MXRADCL+1)
c
c --- Entry point
c
      ny = neq(2)
      nk = neq(3)
      H2O = y(ny+2)
      M   = y(ny+3)
      O2  = y(ny+4)
      CH4 = y(ny+5)
      H2  = y(ny+6)
      N2  = M - O2
c
      do l=1,ny
        Loss(l) = 0.0
        Gain(l) = 0.0
      enddo
c
c --- Get the reaction rates
c
      call ierxn6(y,ny,r,rrk,nk)
c
c --- Solve the steady state species
c
c
c   O1D
c
        Loss(iO1D  )= +( 1.000)*r( 10)+( 1.000)*r( 11)+( 1.000)*r( 38)
c
        Gain(iO1D  )= +( 1.000)*r(  9)
c
      if (loss(iO1D).gt.1.0e-25.or.loss(iO1D).lt.-1.0e-25) then
        y(iO1D) = gain(iO1D)/loss(iO1D)*y(iO1D)
      else
        y(iO1D) = 0.0
      endif
      r( 10) = rrk( 10)*y(iO1D)*M
      r( 11) = rrk( 11)*y(iO1D)*H2O
      r( 38) = rrk( 38)*y(iO1D)*H2
c
c     O
c
        Loss(iO    )= +( 1.000)*r(  2)+( 1.000)*r(  4)+( 1.000)*r(  5)
     &                +( 1.000)*r(  6)+( 1.000)*r( 40)+( 1.000)*r( 44)
     &                +( 1.000)*r( 45)+( 1.000)*r( 46)+( 1.000)*r( 77)
     &                +( 1.000)*r( 84)+( 1.000)*r( 99)+( 1.000)*r(119)
     &                +( 1.000)*r(123)+( 1.000)*r(127)+( 1.000)*r(144)
     &                +( 1.000)*r(153)
c
        Gain(iO    )= +( 1.000)*r(  1)+( 1.000)*r(  8)+( 1.000)*r( 10)
     &                +( 1.000)*r( 14)+( 1.000)*r( 41)+( 0.500)*r(129)
c
      if (loss(iO).gt.1.0e-25.or.loss(iO).lt.-1.0e-25) then
        y(iO) = gain(iO)/loss(iO)*y(iO)
      else
        y(iO) = 0.0
      endif
      r(  2) = rrk(  2)*y(iO)*O2*M
      r(  4) = rrk(  4)*y(iO)*y(iNO2)
      r(  5) = rrk(  5)*y(iO)*y(iNO2)
      r(  6) = rrk(  6)*y(iO)*y(iNO)
      r( 40) = rrk( 40)*y(iOH)*y(iO)
      r( 44) = rrk( 44)*y(iHO2)*y(iO)
      r( 45) = rrk( 45)*y(iH2O2)*y(iO)
      r( 46) = rrk( 46)*y(iNO3)*y(iO)
      r( 77) = rrk( 77)*y(iFORM)*y(iO)
      r( 84) = rrk( 84)*y(iALD2)*y(iO)
      r( 99) = rrk( 99)*y(iALDX)*y(iO)
      r(119) = rrk(119)*y(iO)*y(iOLE)
      r(123) = rrk(123)*y(iO)*y(iETH)
      r(127) = rrk(127)*y(iIOLE)*y(iO)
      r(144) = rrk(144)*y(iO)*y(iISOP)
      r(153) = rrk(153)*y(iTERP)*y(iO)
c
c --- Calculate the Jacobian
c
c
c  N2O5   NO3    OH   HO2  C2O3   XO2  XO2N   TO2   ROR   CRO
c  MEO2  HCO3  CXO3    NO   NO2    O3   PAN  PANX   PNA
c

          jac(iN2O5,iN2O5)= +( 1.000)*r( 19)+( 1.000)*r( 20)
     &                      +( 1.000)*r( 21)+( 1.000)*r( 53)
          jac(iNO3 ,iN2O5)= +(-1.000)*r( 21)+(-1.000)*r( 53)
          jac(iNO2 ,iN2O5)= +(-1.000)*r( 21)+(-1.000)*r( 53)

          jac(iN2O5,iNO3 )= +(-1.000)*r( 18)
          jac(iNO3 ,iNO3 )= +( 1.000)*r( 14)+( 1.000)*r( 15)
     &                      +( 1.000)*r( 16)+( 1.000)*r( 17)
     &                      +( 1.000)*r( 18)+( 1.000)*r( 46)
     &                      +( 1.000)*r( 47)+( 1.000)*r( 48)
     &                      +( 1.000)*r( 49)+( 4.000)*r( 50)
     &                      +( 1.000)*r( 78)+( 1.000)*r( 86)
     &                      +( 1.000)*r(101)+( 1.000)*r(122)
     &                      +( 1.000)*r(126)+( 1.000)*r(130)
     &                      +( 1.000)*r(135)+( 1.000)*r(147)
          jac(iNO3 ,iNO3 )=jac(iNO3 ,iNO3 )
     &                      +( 1.000)*r(151)+( 1.000)*r(156)
          jac(iOH  ,iNO3 )= +( 1.000)*r( 47)
          jac(iHO2 ,iNO3 )= +(-1.000)*r( 47)+( 1.000)*r( 48)
     &                      +(-1.000)*r( 78)+(-1.000)*r(130)
     &                      +(-0.800)*r(147)+(-0.925)*r(151)
     &                      +(-0.280)*r(156)
          jac(iC2O3,iNO3 )= +(-1.000)*r( 86)
          jac(iXO2 ,iNO3 )= +(-0.910)*r(122)+(-1.000)*r(126)
     &                      +(-1.000)*r(147)+(-0.075)*r(151)
     &                      +(-1.030)*r(156)
          jac(iXO2N,iNO3 )= +(-0.090)*r(122)+(-0.250)*r(156)
          jac(iCRO ,iNO3 )= +(-1.000)*r(135)
          jac(iCXO3,iNO3 )= +(-1.000)*r(101)+(-0.075)*r(151)
          jac(iNO  ,iNO3 )= +(-1.000)*r( 15)+( 1.000)*r( 16)
     &                      +(-1.000)*r( 17)
          jac(iNO2 ,iNO3 )= +(-1.000)*r( 14)+(-2.000)*r( 16)
     &                      +( 1.000)*r( 17)+(-1.000)*r( 17)
     &                      +( 1.000)*r( 18)+(-1.000)*r( 46)
     &                      +(-1.000)*r( 47)+(-1.000)*r( 49)
     &                      +(-4.000)*r( 50)+(-1.000)*r(122)
     &                      +(-1.000)*r(126)+(-1.000)*r(130)
     &                      +(-0.200)*r(147)+(-0.470)*r(156)
          jac(iO3  ,iNO3 )= +( 1.000)*r( 49)

          jac(iNO3 ,iOH  )= +(-1.000)*r( 29)+( 1.000)*r( 47)
          jac(iOH  ,iOH  )= +( 1.000)*r( 12)+( 1.000)*r( 24)
     &                      +( 1.000)*r( 26)+( 1.000)*r( 28)
     &                      +( 1.000)*r( 29)+( 1.000)*r( 33)
     &                      +( 1.000)*r( 37)+( 1.000)*r( 39)
     &                      +( 1.000)*r( 40)+( 4.000)*r( 41)
     &                      +( 4.000)*r( 42)+( 1.000)*r( 43)
     &                      +( 1.000)*r( 47)+( 1.000)*r( 61)
     &                      +( 1.000)*r( 63)+( 1.000)*r( 64)
     &                      +( 1.000)*r( 66)+( 1.000)*r( 67)
          jac(iOH  ,iOH  )=jac(iOH  ,iOH  )
     &                      +( 1.000)*r( 71)+( 1.000)*r( 73)
     &                      +( 1.000)*r( 74)+( 1.000)*r( 83)
     &                      +( 1.000)*r( 85)+( 1.000)*r( 96)
     &                      +( 1.000)*r( 98)+( 1.000)*r(100)
     &                      +( 1.000)*r(107)+( 1.000)*r(113)
     &                      +( 1.000)*r(114)+( 1.000)*r(115)
     &                      +( 1.000)*r(120)+( 1.000)*r(124)
     &                      +( 1.000)*r(128)+( 1.000)*r(131)
          jac(iOH  ,iOH  )=jac(iOH  ,iOH  )
     &                      +( 1.000)*r(134)+( 1.000)*r(139)
     &                      +( 1.000)*r(141)+( 1.000)*r(142)
     &                      +( 1.000)*r(145)+( 1.000)*r(149)
     &                      +( 1.000)*r(154)
          jac(iHO2 ,iOH  )= +(-1.000)*r( 12)+(-1.000)*r( 37)
     &                      +(-1.000)*r( 39)+(-1.000)*r( 40)
     &                      +( 1.000)*r( 43)+(-1.000)*r( 47)
     &                      +(-1.000)*r( 61)+(-1.000)*r( 63)
     &                      +(-1.000)*r( 66)+(-0.300)*r( 71)
     &                      +(-1.000)*r( 73)+(-1.000)*r( 74)
     &                      +(-1.000)*r( 83)+(-1.000)*r(113)
     &                      +(-1.000)*r(114)+(-0.110)*r(115)
     &                      +(-0.950)*r(120)+(-1.000)*r(124)
          jac(iHO2 ,iOH  )=jac(iHO2 ,iOH  )
     &                      +(-1.000)*r(128)+(-0.440)*r(131)
     &                      +(-0.600)*r(134)+(-2.000)*r(139)
     &                      +(-0.700)*r(141)+(-0.912)*r(145)
     &                      +(-0.503)*r(149)+(-0.750)*r(154)
          jac(iC2O3,iOH  )= +(-1.000)*r( 85)+(-1.000)*r( 96)
     &                      +(-1.000)*r(139)+(-1.000)*r(142)
     &                      +(-0.210)*r(149)
          jac(iXO2 ,iOH  )= +(-1.000)*r( 64)+(-0.300)*r( 71)
     &                      +(-0.991)*r(113)+(-0.100)*r(114)
     &                      +(-0.870)*r(115)+(-0.800)*r(120)
     &                      +(-1.000)*r(124)+(-1.000)*r(128)
     &                      +(-0.080)*r(131)+(-0.600)*r(134)
     &                      +(-1.000)*r(139)+(-0.500)*r(141)
     &                      +(-1.000)*r(142)+(-0.991)*r(145)
     &                      +(-0.713)*r(149)+(-1.250)*r(154)
          jac(iXO2N,iOH  )= +(-0.009)*r(113)+(-0.130)*r(115)
     &                      +(-0.088)*r(145)+(-0.250)*r(154)
          jac(iTO2 ,iOH  )= +(-0.560)*r(131)+(-0.300)*r(141)
          jac(iROR ,iOH  )= +(-0.760)*r(115)
          jac(iCRO ,iOH  )= +(-0.400)*r(134)
          jac(iMEO2,iOH  )= +(-1.000)*r( 67)+(-0.700)*r( 71)
     &                      +(-1.000)*r( 98)
          jac(iCXO3,iOH  )= +(-1.000)*r(100)+(-0.250)*r(149)
          jac(iNO  ,iOH  )= +( 1.000)*r( 24)
          jac(iNO2 ,iOH  )= +(-1.000)*r( 26)+( 1.000)*r( 28)
     &                      +(-1.000)*r( 33)+(-1.000)*r( 47)
     &                      +(-1.000)*r(107)
          jac(iO3  ,iOH  )= +( 1.000)*r( 12)
          jac(iPANX,iOH  )= +( 1.000)*r(107)
          jac(iPNA ,iOH  )= +( 1.000)*r( 33)

          jac(iNO3 ,iHO2 )= +( 1.000)*r( 48)
          jac(iOH  ,iHO2 )= +(-1.000)*r( 13)+(-1.000)*r( 30)
     &                      +( 1.000)*r( 43)+(-1.000)*r( 44)
          jac(iHO2 ,iHO2 )= +( 1.000)*r( 13)+( 1.000)*r( 30)
     &                      +( 1.000)*r( 31)+( 4.000)*r( 34)
     &                      +( 4.000)*r( 35)+( 1.000)*r( 43)
     &                      +( 1.000)*r( 44)+( 1.000)*r( 48)
     &                      +( 1.000)*r( 56)+( 1.000)*r( 57)
     &                      +( 1.000)*r( 69)+( 1.000)*r( 79)
     &                      +( 1.000)*r( 82)+( 1.000)*r( 92)
     &                      +( 1.000)*r(108)+( 1.000)*r(137)
          jac(iC2O3,iHO2 )= +( 1.000)*r( 92)
          jac(iXO2 ,iHO2 )= +( 1.000)*r( 56)
          jac(iXO2N,iHO2 )= +( 1.000)*r( 57)
          jac(iCRO ,iHO2 )= +( 1.000)*r(137)
          jac(iMEO2,iHO2 )= +( 1.000)*r( 69)
          jac(iHCO3,iHO2 )= +(-1.000)*r( 79)+( 1.000)*r( 82)
          jac(iCXO3,iHO2 )= +( 1.000)*r(108)
          jac(iNO  ,iHO2 )= +( 1.000)*r( 30)
          jac(iNO2 ,iHO2 )= +(-1.000)*r( 30)+( 1.000)*r( 31)
          jac(iO3  ,iHO2 )= +( 1.000)*r( 13)+(-0.200)*r( 92)
     &                      +(-0.200)*r(108)
          jac(iPNA ,iHO2 )= +(-1.000)*r( 31)

          jac(iHO2 ,iC2O3)= +( 1.000)*r( 92)+(-0.900)*r( 93)
     &                      +(-1.000)*r(112)
          jac(iC2O3,iC2O3)= +( 1.000)*r( 88)+( 1.000)*r( 89)
     &                      +( 1.000)*r( 92)+( 1.000)*r( 93)
     &                      +( 1.000)*r( 94)+( 4.000)*r( 95)
     &                      +( 1.000)*r(112)
          jac(iXO2 ,iC2O3)= +( 1.000)*r( 94)+(-1.000)*r(112)
          jac(iMEO2,iC2O3)= +(-1.000)*r( 88)+( 1.000)*r( 93)
     &                      +(-0.900)*r( 93)+(-0.900)*r( 94)
     &                      +(-4.000)*r( 95)+(-1.000)*r(112)
          jac(iCXO3,iC2O3)= +( 1.000)*r(112)
          jac(iNO  ,iC2O3)= +( 1.000)*r( 88)
          jac(iNO2 ,iC2O3)= +(-1.000)*r( 88)+( 1.000)*r( 89)
          jac(iO3  ,iC2O3)= +(-0.200)*r( 92)
          jac(iPAN ,iC2O3)= +(-1.000)*r( 89)

          jac(iHO2 ,iXO2 )= +( 1.000)*r( 56)
          jac(iC2O3,iXO2 )= +( 1.000)*r( 94)
          jac(iXO2 ,iXO2 )= +( 1.000)*r( 54)+( 1.000)*r( 56)
     &                      +( 4.000)*r( 58)+( 1.000)*r( 60)
     &                      +( 1.000)*r( 94)+( 1.000)*r(110)
          jac(iXO2N,iXO2 )= +( 1.000)*r( 60)
          jac(iMEO2,iXO2 )= +(-0.900)*r( 94)
          jac(iCXO3,iXO2 )= +( 1.000)*r(110)
          jac(iNO  ,iXO2 )= +( 1.000)*r( 54)
          jac(iNO2 ,iXO2 )= +(-1.000)*r( 54)

          jac(iHO2 ,iXO2N)= +( 1.000)*r( 57)
          jac(iXO2 ,iXO2N)= +( 1.000)*r( 60)
          jac(iXO2N,iXO2N)= +( 1.000)*r( 55)+( 1.000)*r( 57)
     &                      +( 4.000)*r( 59)+( 1.000)*r( 60)
          jac(iNO  ,iXO2N)= +( 1.000)*r( 55)

          jac(iHO2 ,iTO2 )= +(-0.900)*r(132)+(-1.000)*r(133)
          jac(iTO2 ,iTO2 )= +( 1.000)*r(132)+( 1.000)*r(133)
          jac(iNO  ,iTO2 )= +( 1.000)*r(132)
          jac(iNO2 ,iTO2 )= +(-0.900)*r(132)

          jac(iHO2 ,iROR )= +(-0.940)*r(116)+(-1.000)*r(117)
          jac(iXO2 ,iROR )= +(-0.960)*r(116)
          jac(iXO2N,iROR )= +(-0.040)*r(116)
          jac(iROR ,iROR )= +( 1.000)*r(116)+(-0.020)*r(116)
     &                      +( 1.000)*r(117)+( 1.000)*r(118)
          jac(iNO2 ,iROR )= +( 1.000)*r(118)

          jac(iHO2 ,iCRO )= +( 1.000)*r(137)
          jac(iCRO ,iCRO )= +( 1.000)*r(136)+( 1.000)*r(137)
          jac(iNO2 ,iCRO )= +( 1.000)*r(136)

          jac(iHO2 ,iMEO2)= +(-1.000)*r( 68)+( 1.000)*r( 69)
     &                      +(-1.480)*r( 70)+(-0.900)*r( 93)
     &                      +(-1.000)*r(109)
          jac(iC2O3,iMEO2)= +( 1.000)*r( 93)
          jac(iXO2 ,iMEO2)= +(-0.900)*r(109)
          jac(iMEO2,iMEO2)= +( 1.000)*r( 68)+( 1.000)*r( 69)
     &                      +( 4.000)*r( 70)+( 1.000)*r( 93)
     &                      +(-0.900)*r( 93)+( 1.000)*r(109)
          jac(iCXO3,iMEO2)= +( 1.000)*r(109)
          jac(iNO  ,iMEO2)= +( 1.000)*r( 68)
          jac(iNO2 ,iMEO2)= +(-1.000)*r( 68)

          jac(iHO2 ,iHCO3)= +(-1.000)*r( 80)+(-1.000)*r( 81)
     &                      +( 1.000)*r( 82)
          jac(iHCO3,iHCO3)= +( 1.000)*r( 80)+( 1.000)*r( 81)
     &                      +( 1.000)*r( 82)
          jac(iNO  ,iHCO3)= +( 1.000)*r( 81)
          jac(iNO2 ,iHCO3)= +(-1.000)*r( 81)

          jac(iHO2 ,iCXO3)= +(-1.000)*r(103)+( 1.000)*r(108)
     &                      +(-1.000)*r(109)+(-4.000)*r(111)
     &                      +(-1.000)*r(112)
          jac(iC2O3,iCXO3)= +( 1.000)*r(112)
          jac(iXO2 ,iCXO3)= +(-1.000)*r(103)+(-0.900)*r(109)
     &                      +( 1.000)*r(110)+(-4.000)*r(111)
     &                      +(-1.000)*r(112)
          jac(iMEO2,iCXO3)= +( 1.000)*r(109)+(-1.000)*r(112)
          jac(iCXO3,iCXO3)= +( 1.000)*r(103)+( 1.000)*r(104)
     &                      +( 1.000)*r(108)+( 1.000)*r(109)
     &                      +( 1.000)*r(110)+( 4.000)*r(111)
     &                      +( 1.000)*r(112)
          jac(iNO  ,iCXO3)= +( 1.000)*r(103)
          jac(iNO2 ,iCXO3)= +(-1.000)*r(103)+( 1.000)*r(104)
          jac(iO3  ,iCXO3)= +(-0.200)*r(108)
          jac(iPANX,iCXO3)= +(-1.000)*r(104)

          jac(iNO3 ,iNO  )= +( 1.000)*r( 16)
          jac(iOH  ,iNO  )= +( 1.000)*r( 24)+(-1.000)*r( 30)
          jac(iHO2 ,iNO  )= +( 1.000)*r( 30)+(-1.000)*r( 68)
     &                      +(-1.000)*r( 81)+(-1.000)*r(103)
     &                      +(-0.900)*r(132)
          jac(iC2O3,iNO  )= +( 1.000)*r( 88)
          jac(iXO2 ,iNO  )= +( 1.000)*r( 54)+(-1.000)*r(103)
          jac(iXO2N,iNO  )= +( 1.000)*r( 55)
          jac(iTO2 ,iNO  )= +( 1.000)*r(132)
          jac(iMEO2,iNO  )= +( 1.000)*r( 68)+(-1.000)*r( 88)
          jac(iHCO3,iNO  )= +( 1.000)*r( 81)
          jac(iCXO3,iNO  )= +( 1.000)*r(103)
          jac(iNO  ,iNO  )= +( 1.000)*r(  3)+( 1.000)*r(  6)
     &                      +( 1.000)*r( 16)+( 4.000)*r( 22)
     &                      +( 1.000)*r( 23)+( 1.000)*r( 24)
     &                      +( 1.000)*r( 30)+( 1.000)*r( 54)
     &                      +( 1.000)*r( 55)+( 1.000)*r( 68)
     &                      +( 1.000)*r( 81)+( 1.000)*r( 88)
     &                      +( 1.000)*r(103)+( 1.000)*r(132)
          jac(iNO2 ,iNO  )= +(-1.000)*r(  3)+(-1.000)*r(  6)
     &                      +(-2.000)*r( 16)+(-4.000)*r( 22)
     &                      +( 1.000)*r( 23)+(-1.000)*r( 30)
     &                      +(-1.000)*r( 54)+(-1.000)*r( 68)
     &                      +(-1.000)*r( 81)+(-1.000)*r( 88)
     &                      +(-1.000)*r(103)+(-0.900)*r(132)
          jac(iO3  ,iNO  )= +( 1.000)*r(  3)

          jac(iN2O5,iNO2 )= +(-1.000)*r( 18)
          jac(iNO3 ,iNO2 )= +(-1.000)*r(  5)+(-1.000)*r(  7)
     &                      +( 1.000)*r( 17)+( 1.000)*r( 18)
          jac(iOH  ,iNO2 )= +( 1.000)*r( 28)
          jac(iHO2 ,iNO2 )= +( 1.000)*r( 31)+(-0.800)*r(148)
          jac(iC2O3,iNO2 )= +( 1.000)*r( 89)
          jac(iXO2 ,iNO2 )= +(-1.000)*r(148)
          jac(iROR ,iNO2 )= +( 1.000)*r(118)
          jac(iCRO ,iNO2 )= +( 1.000)*r(136)
          jac(iCXO3,iNO2 )= +( 1.000)*r(104)
          jac(iNO  ,iNO2 )= +(-1.000)*r(  1)+(-1.000)*r(  4)
     &                      +(-1.000)*r( 17)+( 1.000)*r( 23)
     &                      +(-0.200)*r(148)
          jac(iNO2 ,iNO2 )= +( 1.000)*r(  1)+( 1.000)*r(  4)
     &                      +( 1.000)*r(  5)+( 1.000)*r(  7)
     &                      +( 1.000)*r( 17)+(-1.000)*r( 17)
     &                      +( 1.000)*r( 18)+( 1.000)*r( 23)
     &                      +( 1.000)*r( 28)+( 1.000)*r( 31)
     &                      +( 1.000)*r( 89)+( 1.000)*r(104)
     &                      +( 1.000)*r(118)+( 1.000)*r(136)
     &                      +( 1.000)*r(148)
          jac(iO3  ,iNO2 )= +( 1.000)*r(  7)
          jac(iPAN ,iNO2 )= +(-1.000)*r( 89)
          jac(iPANX,iNO2 )= +(-1.000)*r(104)
          jac(iPNA ,iNO2 )= +(-1.000)*r( 31)

          jac(iNO3 ,iO3  )= +(-1.000)*r(  7)+( 1.000)*r( 49)
          jac(iOH  ,iO3  )= +( 1.000)*r( 12)+(-1.000)*r( 13)
     &                      +(-0.100)*r(121)+(-0.130)*r(125)
     &                      +(-0.500)*r(129)+(-0.080)*r(140)
     &                      +(-0.266)*r(146)+(-0.268)*r(150)
     &                      +(-0.570)*r(155)
          jac(iHO2 ,iO3  )= +(-1.000)*r( 12)+( 1.000)*r( 13)
     &                      +(-0.440)*r(121)+(-0.130)*r(125)
     &                      +(-0.500)*r(129)+(-0.760)*r(140)
     &                      +(-0.066)*r(146)+(-0.154)*r(150)
     &                      +(-0.070)*r(155)
          jac(iC2O3,iO3  )= +(-0.620)*r(140)+(-0.114)*r(150)
          jac(iXO2 ,iO3  )= +(-0.220)*r(121)+(-0.030)*r(140)
     &                      +(-0.200)*r(146)+(-0.064)*r(150)
     &                      +(-0.760)*r(155)
          jac(iXO2N,iO3  )= +(-0.180)*r(155)
          jac(iCXO3,iO3  )= +(-0.200)*r(146)+(-0.390)*r(155)
          jac(iNO  ,iO3  )= +( 1.000)*r(  3)
          jac(iNO2 ,iO3  )= +(-1.000)*r(  3)+( 1.000)*r(  7)
     &                      +(-1.000)*r( 49)
          jac(iO3  ,iO3  )= +( 1.000)*r(  3)+( 1.000)*r(  7)
     &                      +( 1.000)*r(  8)+( 1.000)*r(  9)
     &                      +( 1.000)*r( 12)+( 1.000)*r( 13)
     &                      +( 1.000)*r( 49)+( 1.000)*r(121)
     &                      +( 1.000)*r(125)+( 1.000)*r(129)
     &                      +( 1.000)*r(140)+( 1.000)*r(146)
     &                      +( 1.000)*r(150)+( 1.000)*r(155)

          jac(iC2O3,iPAN )= +(-1.000)*r( 90)+(-1.000)*r( 91)
          jac(iNO2 ,iPAN )= +(-1.000)*r( 90)+(-1.000)*r( 91)
          jac(iPAN ,iPAN )= +( 1.000)*r( 90)+( 1.000)*r( 91)

          jac(iOH  ,iPANX)= +( 1.000)*r(107)
          jac(iCXO3,iPANX)= +(-1.000)*r(105)+(-1.000)*r(106)
          jac(iNO2 ,iPANX)= +(-1.000)*r(105)+(-1.000)*r(106)
     &                      +(-1.000)*r(107)
          jac(iPANX,iPANX)= +( 1.000)*r(105)+( 1.000)*r(106)
     &                      +( 1.000)*r(107)

          jac(iNO3 ,iPNA )= +(-0.390)*r( 51)
          jac(iOH  ,iPNA )= +( 1.000)*r( 33)+(-0.390)*r( 51)
          jac(iHO2 ,iPNA )= +(-1.000)*r( 32)+(-0.610)*r( 51)
          jac(iNO2 ,iPNA )= +(-1.000)*r( 32)+(-1.000)*r( 33)
     &                      +(-0.610)*r( 51)
          jac(iPNA ,iPNA )= +( 1.000)*r( 32)+( 1.000)*r( 33)
     &                      +( 1.000)*r( 51)
c
c --- Put the Jacobian in right form for LSODE
c
      do j = 1,neq(1)
        tmp = y(j)
        if( tmp.LT.1.0e-25 .AND. tmp.GT.-1.0e-25 ) then
          tmp = 1.0
        endif
        do i = 1,neq(1)
          jac(i,j) = -jac(i,j)/tmp
        enddo
      enddo
c
      return
      end
