      subroutine ieslow6(r,rate,gain,loss,nr,ny,n1,n2)
      implicit none
c
c----CAMx v5.20.1 1007014
c
c     IESLOW6 computes rates for IEH solver slow species
c
c     Copyright 1996 - 2010
c     ENVIRON International Corporation
c     Created by the CMC version 5.2
c
c     Routines Called:
c        none
c
c     Called by:
c        IEHSOLV
c
      include "camx.prm"
      include "chmdat.com"
      include "iehchem.com"
c
      integer ny, nr, n1, n2, l
      real loss(ny+1)
      real gain(ny+1)
      real rate(ny+1)
      real r(nr)
c
c --- Entry point
c
      do l = n1,n2
        Loss(l) = 0.0
        Gain(l) = 0.0
      enddo
c
c --- Calculate the species rates
c
c
c  HNO3  HONO  H2O2    CO  FORM  ALD2   PAR   NTR   OLE   ETH
c   TOL  CRES  OPEN  MGLY   XYL  ISOP   SO2  SULF  MEOH  ETOH
c  ISPD  ROOH  ALDX  MEPX  FACD  PACD  AACD  ETHA  IOLE  TERP
c
c
        Loss(iHNO3 )= +( 1.000)*r( 29)+( 1.000)*r( 52)
c
        Gain(iHNO3 )= +( 2.000)*r( 19)+( 2.000)*r( 20)+( 1.000)*r( 28)
     &                +( 1.000)*r( 48)+( 1.000)*r( 61)+( 1.000)*r( 78)
     &                +( 1.000)*r( 86)+( 1.000)*r(101)+( 1.000)*r(135)
     &                +( 0.150)*r(151)
c
        Loss(iHONO )= +( 1.000)*r( 25)+( 1.000)*r( 26)+( 2.000)*r( 27)
c
        Gain(iHONO )= +( 2.000)*r( 23)+( 1.000)*r( 24)
c
        Loss(iH2O2 )= +( 1.000)*r( 36)+( 1.000)*r( 37)+( 1.000)*r( 45)
c
        Gain(iH2O2 )= +( 1.000)*r( 34)+( 1.000)*r( 35)+( 1.000)*r( 42)
c
        Loss(iCO   )= +( 1.000)*r( 66)
c
        Gain(iCO   )= +( 1.000)*r( 74)+( 1.000)*r( 75)+( 1.000)*r( 76)
     &                +( 1.000)*r( 77)+( 1.000)*r( 78)+( 1.000)*r( 87)
     &                +( 1.000)*r(102)+( 0.200)*r(119)+( 0.330)*r(121)
     &                +( 1.000)*r(123)+( 0.630)*r(125)+( 0.100)*r(127)
     &                +( 0.250)*r(129)+( 1.000)*r(138)+( 2.000)*r(139)
     &                +( 0.690)*r(140)+( 1.000)*r(143)+( 0.066)*r(146)
     &                +( 0.334)*r(149)+( 0.225)*r(150)+( 0.643)*r(151)
     &                +( 0.333)*r(152)+( 0.001)*r(155)
c
        Loss(iFORM )= +( 1.000)*r( 74)+( 1.000)*r( 75)+( 1.000)*r( 76)
     &                +( 1.000)*r( 77)+( 1.000)*r( 78)+( 1.000)*r( 79)
c
        Gain(iFORM )= +( 0.330)*r( 61)+( 0.330)*r( 62)+( 1.000)*r( 68)
     &                +( 1.370)*r( 70)+( 1.000)*r( 72)+( 1.000)*r( 73)
     &                +( 1.000)*r( 80)+( 1.000)*r( 93)+( 0.100)*r(109)
     &                +( 0.100)*r(114)+( 0.200)*r(119)+( 0.800)*r(120)
     &                +( 0.740)*r(121)+( 1.000)*r(122)+( 1.000)*r(123)
     &                +( 1.560)*r(124)+( 1.000)*r(125)+( 2.000)*r(126)
     &                +( 0.250)*r(129)+( 1.000)*r(139)+( 0.700)*r(140)
     &                +( 0.500)*r(144)+( 0.629)*r(145)+( 0.600)*r(146)
     &                +( 0.167)*r(149)+( 0.150)*r(150)+( 0.282)*r(151)
        Gain(iFORM ) = Gain(iFORM )
     &                +( 0.900)*r(152)+( 0.280)*r(154)+( 0.240)*r(155)
c
        Loss(iALD2 )= +( 1.000)*r( 84)+( 1.000)*r( 85)+( 1.000)*r( 86)
     &                +( 1.000)*r( 87)
c
        Gain(iALD2 )= +( 0.330)*r( 61)+( 0.330)*r( 62)+( 0.500)*r( 64)
     &                +( 0.500)*r( 65)+( 1.000)*r(103)+( 1.000)*r(107)
     &                +( 0.900)*r(109)+( 0.900)*r(110)+( 2.000)*r(111)
     &                +( 1.000)*r(112)+( 0.991)*r(113)+( 0.900)*r(114)
     &                +( 0.060)*r(115)+( 0.600)*r(116)+( 0.200)*r(119)
     &                +( 0.330)*r(120)+( 0.180)*r(121)+( 0.350)*r(122)
     &                +( 1.240)*r(127)+( 1.300)*r(128)+( 0.650)*r(129)
     &                +( 1.180)*r(130)+( 0.252)*r(149)+( 0.020)*r(150)
     &                +( 0.067)*r(152)
c
        Loss(iPAR  )= +( 1.000)*r(115)
c
        Gain(iPAR  )= +(-0.660)*r( 61)+(-0.660)*r( 62)+(-0.110)*r(115)
     &                +(-2.100)*r(116)+( 0.200)*r(119)+(-0.700)*r(120)
     &                +(-1.000)*r(121)+(-1.000)*r(122)+( 0.100)*r(127)
     &                +( 1.100)*r(141)+( 0.250)*r(144)+( 0.350)*r(146)
     &                +( 2.400)*r(147)+( 2.400)*r(148)+( 1.565)*r(149)
     &                +( 0.360)*r(150)+( 1.282)*r(151)+( 0.832)*r(152)
     &                +( 5.120)*r(153)+( 1.660)*r(154)+( 7.000)*r(155)
c
        Loss(iNTR  )= +( 1.000)*r( 61)+( 1.000)*r( 62)
c
        Gain(iNTR  )= +( 1.000)*r( 55)+( 1.000)*r(118)+( 0.100)*r(132)
     &                +( 1.000)*r(136)+( 0.800)*r(147)+( 0.800)*r(148)
     &                +( 0.850)*r(151)+( 0.530)*r(156)
c
        Loss(iOLE  )= +( 1.000)*r(119)+( 1.000)*r(120)+( 1.000)*r(121)
     &                +( 1.000)*r(122)
c
        Gain(iOLE  )= 0.0
c
        Loss(iETH  )= +( 1.000)*r(123)+( 1.000)*r(124)+( 1.000)*r(125)
     &                +( 1.000)*r(126)
c
        Gain(iETH  )= 0.0
c
        Loss(iTOL  )= +( 1.000)*r(131)
c
        Gain(iTOL  )= 0.0
c
        Loss(iCRES )= +( 1.000)*r(134)+( 1.000)*r(135)
c
        Gain(iCRES )= +( 0.360)*r(131)+( 1.000)*r(133)+( 1.000)*r(137)
     &                +( 0.200)*r(141)
c
        Loss(iOPEN )= +( 1.000)*r(138)+( 1.000)*r(139)+( 1.000)*r(140)
c
        Gain(iOPEN )= +( 0.900)*r(132)+( 0.300)*r(134)
c
        Loss(iMGLY )= +( 1.000)*r(142)+( 1.000)*r(143)
c
        Gain(iMGLY )= +( 0.200)*r(140)+( 0.800)*r(141)+( 0.168)*r(149)
     &                +( 0.850)*r(150)
c
        Loss(iXYL  )= +( 1.000)*r(141)
c
        Gain(iXYL  )= 0.0
c
        Loss(iISOP )= +( 1.000)*r(144)+( 1.000)*r(145)+( 1.000)*r(146)
     &                +( 1.000)*r(147)+( 1.000)*r(148)
c
        Gain(iISOP )= 0.0
c
        Loss(iSO2  )= +( 1.000)*r( 63)
c
        Gain(iSO2  )= 0.0
c
        Loss(iSULF )= 0.0
c
        Gain(iSULF )= +( 1.000)*r( 63)
c
        Loss(iMEOH )= +( 1.000)*r( 73)
c
        Gain(iMEOH )= +( 0.630)*r( 70)
c
        Loss(iETOH )= +( 1.000)*r(114)
c
        Gain(iETOH )= 0.0
c
        Loss(iISPD )= +( 1.000)*r(149)+( 1.000)*r(150)+( 1.000)*r(151)
     &                +( 1.000)*r(152)
c
        Gain(iISPD )= +( 0.750)*r(144)+( 0.912)*r(145)+( 0.650)*r(146)
     &                +( 0.200)*r(147)+( 0.200)*r(148)
c
        Loss(iROOH )= +( 1.000)*r( 64)+( 1.000)*r( 65)
c
        Gain(iROOH )= +( 1.000)*r( 56)+( 1.000)*r( 57)
c
        Loss(iALDX )= +( 1.000)*r( 99)+( 1.000)*r(100)+( 1.000)*r(101)
     &                +( 1.000)*r(102)
c
        Gain(iALDX )= +( 0.330)*r( 61)+( 0.330)*r( 62)+( 0.500)*r( 64)
     &                +( 0.500)*r( 65)+( 0.050)*r(114)+( 0.050)*r(115)
     &                +( 0.500)*r(116)+( 0.300)*r(119)+( 0.620)*r(120)
     &                +( 0.320)*r(121)+( 0.560)*r(122)+( 0.220)*r(124)
     &                +( 0.660)*r(127)+( 0.700)*r(128)+( 0.350)*r(129)
     &                +( 0.640)*r(130)+( 0.030)*r(140)+( 0.150)*r(146)
     &                +( 0.800)*r(147)+( 0.800)*r(148)+( 0.120)*r(149)
     &                +( 0.357)*r(151)+( 0.150)*r(153)+( 0.470)*r(154)
     &                +( 0.210)*r(155)+( 0.470)*r(156)
c
        Loss(iMEPX )= +( 1.000)*r( 71)+( 1.000)*r( 72)
c
        Gain(iMEPX )= +( 1.000)*r( 69)+( 1.000)*r( 82)
c
        Loss(iFACD )= +( 1.000)*r( 83)
c
        Gain(iFACD )= +( 1.000)*r( 81)+( 0.370)*r(125)
c
        Loss(iPACD )= +( 1.000)*r( 96)+( 1.000)*r( 97)
c
        Gain(iPACD )= +( 0.800)*r( 92)+( 0.800)*r(108)
c
        Loss(iAACD )= +( 1.000)*r( 98)
c
        Gain(iAACD )= +( 0.200)*r( 92)+( 0.100)*r( 93)+( 0.100)*r( 94)
     &                +( 0.200)*r(108)+( 0.100)*r(109)+( 0.100)*r(110)
c
        Loss(iETHA )= +( 1.000)*r(113)
c
        Gain(iETHA )= 0.0
c
        Loss(iIOLE )= +( 1.000)*r(127)+( 1.000)*r(128)+( 1.000)*r(129)
     &                +( 1.000)*r(130)
c
        Gain(iIOLE )= 0.0
c
        Loss(iTERP )= +( 1.000)*r(153)+( 1.000)*r(154)+( 1.000)*r(155)
     &                +( 1.000)*r(156)
c
        Gain(iTERP )= 0.0
c
c
      do l=n1,n2
        rate(l) = gain(l) -loss(l)
      enddo
c
      return
      end
