      subroutine lsrxn5(H2O,M,O2,CH4,H2,y,dbrk,r)
      implicit none
c
c----CAMx v5.20.1 1007014
c
c     LSRXN5 computes double precision fluxes for each reaction
c
c     Copyright 1996 - 2010
c     ENVIRON International Corporation
c     Created by the CMC version 5.2
c
c     Routines Called:
c        none
c
c     Called by:
c        LSRATE5
c
      include "camx.prm"
      include "chmdat.com"
      include "ddmchm.com"
c
      double precision H2O, M, O2, CH4, H2, N2
      double precision y(*)
      double precision dbrk(*)
      double precision r(*)
c
c --- Entry point
c
      N2  = M - O2
      r(  1) = dbrk(  1)*y(lNO2)
      r(  2) = dbrk(  2)*y(lO)*O2*M
      r(  3) = dbrk(  3)*y(lO)*y(lO3)
      r(  4) = dbrk(  4)*y(lO)*y(lNO)*M
      r(  5) = dbrk(  5)*y(lO)*y(lNO2)
      r(  6) = dbrk(  6)*y(lO)*y(lNO2)
      r(  7) = dbrk(  7)*y(lO3)*y(lNO)
      r(  8) = dbrk(  8)*y(lO3)*y(lNO2)
      r(  9) = dbrk(  9)*y(lNO)*y(lNO3)
      r( 10) = dbrk( 10)*y(lNO)*y(lNO)*O2
      r( 11) = dbrk( 11)*y(lNO2)*y(lNO3)
      r( 12) = dbrk( 12)*y(lN2O5)
      r( 13) = dbrk( 13)*y(lN2O5)*H2O
      r( 14) = dbrk( 14)*y(lNO2)*y(lNO3)
      r( 15) = dbrk( 15)*y(lNO3)
      r( 16) = dbrk( 16)*y(lNO3)
      r( 17) = dbrk( 17)*y(lO3)
      r( 18) = dbrk( 18)*y(lO3)
      r( 19) = dbrk( 19)*y(lO1D)*H2O
      r( 20) = dbrk( 20)*y(lO1D)*M
      r( 21) = dbrk( 21)*y(lOH)*y(lNO)
      r( 22) = dbrk( 22)*y(lHONO)
      r( 23) = dbrk( 23)*y(lHONO)
      r( 24) = dbrk( 24)*y(lOH)*y(lHONO)
      r( 25) = dbrk( 25)*y(lOH)*y(lNO2)
      r( 26) = dbrk( 26)*y(lOH)*y(lNO3)
      r( 27) = dbrk( 27)*y(lOH)*y(lHNO3)
      r( 28) = dbrk( 28)*y(lHNO3)
      r( 29) = dbrk( 29)*y(lOH)*y(lCO)
      r( 30) = dbrk( 30)*y(lOH)*y(lO3)
      r( 31) = dbrk( 31)*y(lHO2)*y(lNO)
      r( 32) = dbrk( 32)*y(lHO2)*y(lNO2)
      r( 33) = dbrk( 33)*y(lHNO4)
      r( 34) = dbrk( 34)*y(lHNO4)
      r( 35) = dbrk( 35)*y(lHNO4)*y(lOH)
      r( 36) = dbrk( 36)*y(lHO2)*y(lO3)
      r( 37) = dbrk( 37)*y(lHO2)*y(lHO2)
      r( 38) = dbrk( 38)*y(lHO2)*y(lHO2)*H2O
      r( 39) = dbrk( 39)*y(lNO3)*y(lHO2)
      r( 40) = dbrk( 40)*y(lNO3)*y(lNO3)
      r( 41) = dbrk( 41)*y(lHO2H)
      r( 42) = dbrk( 42)*y(lHO2H)*y(lOH)
      r( 43) = dbrk( 43)*y(lOH)*y(lHO2)
      r( 44) = dbrk( 44)*y(lOH)*y(lSO2)
      r( 45) = dbrk( 45)*y(lOH)*H2
      r( 46) = dbrk( 46)*y(lCXO2)*y(lNO)
      r( 47) = dbrk( 47)*y(lCXO2)*y(lHO2)
      r( 48) = dbrk( 48)*y(lCXO2)*y(lNO3)
      r( 49) = dbrk( 49)*y(lCXO2)*y(lCXO2)
      r( 50) = dbrk( 50)*y(lCXO2)*y(lCXO2)
      r( 51) = dbrk( 51)*y(lRO2R)*y(lNO)
      r( 52) = dbrk( 52)*y(lRO2R)*y(lHO2)
      r( 53) = dbrk( 53)*y(lRO2R)*y(lNO3)
      r( 54) = dbrk( 54)*y(lRO2R)*y(lCXO2)
      r( 55) = dbrk( 55)*y(lRO2R)*y(lRO2R)
      r( 56) = dbrk( 56)*y(lR2O2)*y(lNO)
      r( 57) = dbrk( 57)*y(lR2O2)*y(lHO2)
      r( 58) = dbrk( 58)*y(lR2O2)*y(lNO3)
      r( 59) = dbrk( 59)*y(lR2O2)*y(lCXO2)
      r( 60) = dbrk( 60)*y(lR2O2)*y(lRO2R)
      r( 61) = dbrk( 61)*y(lR2O2)*y(lR2O2)
      r( 62) = dbrk( 62)*y(lRO2N)*y(lNO)
      r( 63) = dbrk( 63)*y(lRO2N)*y(lHO2)
      r( 64) = dbrk( 64)*y(lRO2N)*y(lCXO2)
      r( 65) = dbrk( 65)*y(lRO2N)*y(lNO3)
      r( 66) = dbrk( 66)*y(lRO2N)*y(lRO2R)
      r( 67) = dbrk( 67)*y(lRO2N)*y(lR2O2)
      r( 68) = dbrk( 68)*y(lRO2N)*y(lRO2N)
      r( 69) = dbrk( 69)*y(lCCO3)*y(lNO2)
      r( 70) = dbrk( 70)*y(lPAN)
      r( 71) = dbrk( 71)*y(lCCO3)*y(lNO)
      r( 72) = dbrk( 72)*y(lCCO3)*y(lHO2)
      r( 73) = dbrk( 73)*y(lCCO3)*y(lNO3)
      r( 74) = dbrk( 74)*y(lCCO3)*y(lCXO2)
      r( 75) = dbrk( 75)*y(lCCO3)*y(lRO2R)
      r( 76) = dbrk( 76)*y(lCCO3)*y(lR2O2)
      r( 77) = dbrk( 77)*y(lCCO3)*y(lRO2N)
      r( 78) = dbrk( 78)*y(lCCO3)*y(lCCO3)
      r( 79) = dbrk( 79)*y(lRCO3)*y(lNO2)
      r( 80) = dbrk( 80)*y(lPAN2)
      r( 81) = dbrk( 81)*y(lRCO3)*y(lNO)
      r( 82) = dbrk( 82)*y(lRCO3)*y(lHO2)
      r( 83) = dbrk( 83)*y(lRCO3)*y(lNO3)
      r( 84) = dbrk( 84)*y(lRCO3)*y(lCXO2)
      r( 85) = dbrk( 85)*y(lRCO3)*y(lRO2R)
      r( 86) = dbrk( 86)*y(lRCO3)*y(lR2O2)
      r( 87) = dbrk( 87)*y(lRCO3)*y(lRO2N)
      r( 88) = dbrk( 88)*y(lRCO3)*y(lCCO3)
      r( 89) = dbrk( 89)*y(lRCO3)*y(lRCO3)
      r( 90) = dbrk( 90)*y(lBZCO)*y(lNO2)
      r( 91) = dbrk( 91)*y(lPBZN)
      r( 92) = dbrk( 92)*y(lBZCO)*y(lNO)
      r( 93) = dbrk( 93)*y(lBZCO)*y(lHO2)
      r( 94) = dbrk( 94)*y(lBZCO)*y(lNO3)
      r( 95) = dbrk( 95)*y(lBZCO)*y(lCXO2)
      r( 96) = dbrk( 96)*y(lBZCO)*y(lRO2R)
      r( 97) = dbrk( 97)*y(lBZCO)*y(lR2O2)
      r( 98) = dbrk( 98)*y(lBZCO)*y(lRO2N)
      r( 99) = dbrk( 99)*y(lBZCO)*y(lCCO3)
      r(100) = dbrk(100)*y(lBZCO)*y(lRCO3)
      r(101) = dbrk(101)*y(lBZCO)*y(lBZCO)
      r(102) = dbrk(102)*y(lMCO3)*y(lNO2)
      r(103) = dbrk(103)*y(lMPAN)
      r(104) = dbrk(104)*y(lMCO3)*y(lNO)
      r(105) = dbrk(105)*y(lMCO3)*y(lHO2)
      r(106) = dbrk(106)*y(lMCO3)*y(lNO3)
      r(107) = dbrk(107)*y(lMCO3)*y(lCXO2)
      r(108) = dbrk(108)*y(lMCO3)*y(lRO2R)
      r(109) = dbrk(109)*y(lMCO3)*y(lR2O2)
      r(110) = dbrk(110)*y(lMCO3)*y(lRO2N)
      r(111) = dbrk(111)*y(lMCO3)*y(lCCO3)
      r(112) = dbrk(112)*y(lMCO3)*y(lRCO3)
      r(113) = dbrk(113)*y(lMCO3)*y(lBZCO)
      r(114) = dbrk(114)*y(lMCO3)*y(lMCO3)
      r(115) = dbrk(115)*y(lTBUO)*y(lNO2)
      r(116) = dbrk(116)*y(lTBUO)
      r(117) = dbrk(117)*y(lBZO)*y(lNO2)
      r(118) = dbrk(118)*y(lBZO)*y(lHO2)
      r(119) = dbrk(119)*y(lBZO)
      r(120) = dbrk(120)*y(lBZNO)*y(lNO2)
      r(121) = dbrk(121)*y(lBZNO)*y(lHO2)
      r(122) = dbrk(122)*y(lBZNO)
      r(123) = dbrk(123)*y(lHCHO)
      r(124) = dbrk(124)*y(lHCHO)
      r(125) = dbrk(125)*y(lHCHO)*y(lOH)
      r(126) = dbrk(126)*y(lHCHO)*y(lHO2)
      r(127) = dbrk(127)*y(lHCO3)
      r(128) = dbrk(128)*y(lHCO3)*y(lNO)
      r(129) = dbrk(129)*y(lHCHO)*y(lNO3)
      r(130) = dbrk(130)*y(lCCHO)*y(lOH)
      r(131) = dbrk(131)*y(lCCHO)
      r(132) = dbrk(132)*y(lCCHO)*y(lNO3)
      r(133) = dbrk(133)*y(lRCHO)*y(lOH)
      r(134) = dbrk(134)*y(lRCHO)
      r(135) = dbrk(135)*y(lRCHO)*y(lNO3)
      r(136) = dbrk(136)*y(lACET)*y(lOH)
      r(137) = dbrk(137)*y(lACET)
      r(138) = dbrk(138)*y(lMEK)*y(lOH)
      r(139) = dbrk(139)*y(lMEK)
      r(140) = dbrk(140)*y(lMEOH)*y(lOH)
      r(141) = dbrk(141)*y(lCOOH)*y(lOH)
      r(142) = dbrk(142)*y(lCOOH)
      r(143) = dbrk(143)*y(lROOH)*y(lOH)
      r(144) = dbrk(144)*y(lROOH)
      r(145) = dbrk(145)*y(lGLY)
      r(146) = dbrk(146)*y(lGLY)
      r(147) = dbrk(147)*y(lGLY)*y(lOH)
      r(148) = dbrk(148)*y(lGLY)*y(lNO3)
      r(149) = dbrk(149)*y(lMGLY)
      r(150) = dbrk(150)*y(lMGLY)*y(lOH)
      r(151) = dbrk(151)*y(lMGLY)*y(lNO3)
      r(152) = dbrk(152)*y(lBACL)
      r(153) = dbrk(153)*y(lPHEN)*y(lOH)
      r(154) = dbrk(154)*y(lPHEN)*y(lNO3)
      r(155) = dbrk(155)*y(lCRES)*y(lOH)
      r(156) = dbrk(156)*y(lCRES)*y(lNO3)
      r(157) = dbrk(157)*y(lNPHE)*y(lNO3)
      r(158) = dbrk(158)*y(lBALD)*y(lOH)
      r(159) = dbrk(159)*y(lBALD)
      r(160) = dbrk(160)*y(lBALD)*y(lNO3)
      r(161) = dbrk(161)*y(lMETH)*y(lOH)
      r(162) = dbrk(162)*y(lMETH)*y(lO3)
      r(163) = dbrk(163)*y(lMETH)*y(lNO3)
      r(164) = dbrk(164)*y(lMETH)*y(lO)
      r(165) = dbrk(165)*y(lMETH)
      r(166) = dbrk(166)*y(lMVK)*y(lOH)
      r(167) = dbrk(167)*y(lMVK)*y(lO3)
      r(168) = dbrk(168)*y(lMVK)*y(lO)
      r(169) = dbrk(169)*y(lMVK)
      r(170) = dbrk(170)*y(lISPD)*y(lOH)
      r(171) = dbrk(171)*y(lISPD)*y(lO3)
      r(172) = dbrk(172)*y(lISPD)*y(lNO3)
      r(173) = dbrk(173)*y(lISPD)
      r(174) = dbrk(174)*y(lPROD)*y(lOH)
      r(175) = dbrk(175)*y(lPROD)
      r(176) = dbrk(176)*y(lRNO3)*y(lOH)
      r(177) = dbrk(177)*y(lRNO3)
      r(178) = dbrk(178)*y(lDCB1)*y(lOH)
      r(179) = dbrk(179)*y(lDCB1)*y(lO3)
      r(180) = dbrk(180)*y(lDCB2)*y(lOH)
      r(181) = dbrk(181)*y(lDCB2)
      r(182) = dbrk(182)*y(lDCB3)*y(lOH)
      r(183) = dbrk(183)*y(lDCB3)
      r(184) = dbrk(184)*CH4*y(lOH)
      r(185) = dbrk(185)*y(lETHE)*y(lOH)
      r(186) = dbrk(186)*y(lETHE)*y(lO3)
      r(187) = dbrk(187)*y(lETHE)*y(lNO3)
      r(188) = dbrk(188)*y(lETHE)*y(lO)
      r(189) = dbrk(189)*y(lISOP)*y(lOH)
      r(190) = dbrk(190)*y(lISOP)*y(lO3)
      r(191) = dbrk(191)*y(lISOP)*y(lNO3)
      r(192) = dbrk(192)*y(lISOP)*y(lO)
      r(193) = dbrk(193)*y(lTERP)*y(lOH)
      r(194) = dbrk(194)*y(lTERP)*y(lO3)
      r(195) = dbrk(195)*y(lTERP)*y(lNO3)
      r(196) = dbrk(196)*y(lTERP)*y(lO)
      r(197) = dbrk(197)*y(lALK1)*y(lOH)
      r(198) = dbrk(198)*y(lALK2)*y(lOH)
      r(199) = dbrk(199)*y(lALK3)*y(lOH)
      r(200) = dbrk(200)*y(lALK4)*y(lOH)
      r(201) = dbrk(201)*y(lALK5)*y(lOH)
      r(202) = dbrk(202)*y(lARO1)*y(lOH)
      r(203) = dbrk(203)*y(lARO2)*y(lOH)
      r(204) = dbrk(204)*y(lOLE1)*y(lOH)
      r(205) = dbrk(205)*y(lOLE1)*y(lO3)
      r(206) = dbrk(206)*y(lOLE1)*y(lNO3)
      r(207) = dbrk(207)*y(lOLE1)*y(lO)
      r(208) = dbrk(208)*y(lOLE2)*y(lOH)
      r(209) = dbrk(209)*y(lOLE2)*y(lO3)
      r(210) = dbrk(210)*y(lOLE2)*y(lNO3)
      r(211) = dbrk(211)*y(lOLE2)*y(lO)
      r(212) = dbrk(212)*y(lETOH)*y(lOH)
      r(213) = dbrk(213)*y(lMTBE)*y(lOH)
      r(214) = dbrk(214)*y(lMBUT)*y(lOH)
      r(215) = dbrk(215)*y(lMBUT)*y(lO3)
      r(216) = dbrk(216)*y(lMBUT)*y(lNO3)
      r(217) = dbrk(217)*y(lMBUT)*y(lO)
c
      return
      end
